Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -3263,102 +3234,102 @@
           IF (bf<0.0) fac2 = -1.0
           bf = abs(bf)
-          ur = 0.25*bf*bf - af*af*af*tinv*tinv*tinv
+          ur = 0.25 * bf * bf - af * af * af * tinv * tinv * tinv
           IF (ur>=0.0) THEN
             sru = sqrt(ur)
             fac = 1.0
-            IF ((0.5*bf-sru)<0.0) fac = -1.0
-            mp(il, i) = mp(il, i+1)*tinv + (0.5*bf+sru)**tinv + &
-                                           fac*(abs(0.5*bf-sru))**tinv
+            IF ((0.5 * bf - sru)<0.0) fac = -1.0
+            mp(il, i) = mp(il, i + 1) * tinv + (0.5 * bf + sru)**tinv + &
+                    fac * (abs(0.5 * bf - sru))**tinv
           ELSE
-            d = atan(2.*sqrt(-ur)/(bf+1.0E-28))
+            d = atan(2. * sqrt(-ur) / (bf + 1.0E-28))
             IF (fac2<0.0) d = 3.14159 - d
-            mp(il, i) = mp(il, i+1)*tinv + 2.*sqrt(af*tinv)*cos(d*tinv)
+            mp(il, i) = mp(il, i + 1) * tinv + 2. * sqrt(af * tinv) * cos(d * tinv)
           END IF
-          mp(il, i) = max(0.0, mp(il,i))
+          mp(il, i) = max(0.0, mp(il, i))
           IF (prt_level >= 20) THEN
-            PRINT *,'cv3_unsat, mp cubic ', i, mp(il,i)
+            PRINT *, 'cv3_unsat, mp cubic ', i, mp(il, i)
           ENDIF
 
           IF (cvflag_ice) THEN
             IF (cvflag_grav) THEN
-!JYG : il y a vraisemblablement une erreur dans la ligne 2 suivante:
-! il faut diviser par (mp(il,i)*sigd(il)*grav) et non par (mp(il,i)+sigd(il)*0.1).
-! Et il faut bien revoir les facteurs 100.
-              b(il, i-1) = b(il, i) + 100.0*(p(il,i-1)-p(il,i))* &
-                           (tevap(il)*(1.+(lf(il,i)/lv(il,i))*faci(il,i)) + &
-                           (lf(il,i)/lv(il,i))*wt(il,i)/100.*fondue(il,i) / &
-                           (ph(il,i)-ph(il,i+1))) / &
-                           (mp(il,i)+sigd(il)*0.1) - &
-                           10.0*(th(il,i)-th(il,i-1))*t(il, i) / &
-                           (lvcp(il,i)*sigd(il)*th(il,i))
+              !JYG : il y a vraisemblablement une erreur dans la ligne 2 suivante:
+              ! il faut diviser par (mp(il,i)*sigd(il)*grav) et non par (mp(il,i)+sigd(il)*0.1).
+              ! Et il faut bien revoir les facteurs 100.
+              b(il, i - 1) = b(il, i) + 100.0 * (p(il, i - 1) - p(il, i)) * &
+                      (tevap(il) * (1. + (lf(il, i) / lv(il, i)) * faci(il, i)) + &
+                              (lf(il, i) / lv(il, i)) * wt(il, i) / 100. * fondue(il, i) / &
+                                      (ph(il, i) - ph(il, i + 1))) / &
+                      (mp(il, i) + sigd(il) * 0.1) - &
+                      10.0 * (th(il, i) - th(il, i - 1)) * t(il, i) / &
+                              (lvcp(il, i) * sigd(il) * th(il, i))
             ELSE
-              b(il, i-1) = b(il, i) + 100.0*(p(il,i-1)-p(il,i))*&
-                           (tevap(il)*(1.+(lf(il,i)/lv(il,i))*faci(il,i)) + &
-                           (lf(il,i)/lv(il,i))*wt(il,i)/100.*fondue(il,i) / &
-                           (ph(il,i)-ph(il,i+1))) / &
-                           (mp(il,i)+sigd(il)*0.1) - &
-                           10.0*(th(il,i)-th(il,i-1))*t(il, i) / &
-                           (lvcp(il,i)*sigd(il)*th(il,i))
+              b(il, i - 1) = b(il, i) + 100.0 * (p(il, i - 1) - p(il, i)) * &
+                      (tevap(il) * (1. + (lf(il, i) / lv(il, i)) * faci(il, i)) + &
+                              (lf(il, i) / lv(il, i)) * wt(il, i) / 100. * fondue(il, i) / &
+                                      (ph(il, i) - ph(il, i + 1))) / &
+                      (mp(il, i) + sigd(il) * 0.1) - &
+                      10.0 * (th(il, i) - th(il, i - 1)) * t(il, i) / &
+                              (lvcp(il, i) * sigd(il) * th(il, i))
             END IF
           ELSE
             IF (cvflag_grav) THEN
-              b(il, i-1) = b(il, i) + 100.0*(p(il,i-1)-p(il,i))*tevap(il) / &
-                           (mp(il,i)+sigd(il)*0.1) - &
-                           10.0*(th(il,i)-th(il,i-1))*t(il, i) / &
-                           (lvcp(il,i)*sigd(il)*th(il,i))
+              b(il, i - 1) = b(il, i) + 100.0 * (p(il, i - 1) - p(il, i)) * tevap(il) / &
+                      (mp(il, i) + sigd(il) * 0.1) - &
+                      10.0 * (th(il, i) - th(il, i - 1)) * t(il, i) / &
+                              (lvcp(il, i) * sigd(il) * th(il, i))
             ELSE
-              b(il, i-1) = b(il, i) + 100.0*(p(il,i-1)-p(il,i))*tevap(il) / &
-                           (mp(il,i)+sigd(il)*0.1) - &
-                           10.0*(th(il,i)-th(il,i-1))*t(il, i) / &
-                           (lvcp(il,i)*sigd(il)*th(il,i))
+              b(il, i - 1) = b(il, i) + 100.0 * (p(il, i - 1) - p(il, i)) * tevap(il) / &
+                      (mp(il, i) + sigd(il) * 0.1) - &
+                      10.0 * (th(il, i) - th(il, i - 1)) * t(il, i) / &
+                              (lvcp(il, i) * sigd(il) * th(il, i))
             END IF
           END IF
-          b(il, i-1) = max(b(il,i-1), 0.0)
+          b(il, i - 1) = max(b(il, i - 1), 0.0)
 
         END IF !(amp2.gt.(0.1*amfac))
 
-!jyg<    This part shifted 10 lines farther
-!!! ***         limit magnitude of mp(i) to meet cfl condition      ***
-!!
-!!        ampmax = 2.0*(ph(il,i)-ph(il,i+1))*delti
-!!        amp2 = 2.0*(ph(il,i-1)-ph(il,i))*delti
-!!        ampmax = min(ampmax, amp2)
-!!        mp(il, i) = min(mp(il,i), ampmax)
-!>jyg
-
-! ***      force mp to decrease linearly to zero                 ***
-! ***       between cloud base and the surface                   ***
-
-
-! c      IF(p(il,i).gt.p(il,icb(il)))THEN
-! c       mp(il,i)=mp(il,icb(il))*(p(il,1)-p(il,i))/(p(il,1)-p(il,icb(il)))
-! c      endif
-        IF (ph(il,i)>0.9*plcl(il)) THEN
-          mp(il, i) = mp(il, i)*(ph(il,1)-ph(il,i))/(ph(il,1)-0.9*plcl(il))
+        !jyg<    This part shifted 10 lines farther
+        !!! ***         limit magnitude of mp(i) to meet cfl condition      ***
+        !!
+        !!        ampmax = 2.0*(ph(il,i)-ph(il,i+1))*delti
+        !!        amp2 = 2.0*(ph(il,i-1)-ph(il,i))*delti
+        !!        ampmax = min(ampmax, amp2)
+        !!        mp(il, i) = min(mp(il,i), ampmax)
+        !>jyg
+
+        ! ***      force mp to decrease linearly to zero                 ***
+        ! ***       between cloud base and the surface                   ***
+
+
+        ! c      IF(p(il,i).gt.p(il,icb(il)))THEN
+        ! c       mp(il,i)=mp(il,icb(il))*(p(il,1)-p(il,i))/(p(il,1)-p(il,icb(il)))
+        ! c      endif
+        IF (ph(il, i)>0.9 * plcl(il)) THEN
+          mp(il, i) = mp(il, i) * (ph(il, 1) - ph(il, i)) / (ph(il, 1) - 0.9 * plcl(il))
         END IF
 
-!jyg<    Shifted part
-! ***         limit magnitude of mp(i) to meet cfl condition      ***
-
-        ampmax = 2.0*(ph(il,i)-ph(il,i+1))*delti
-        amp2 = 2.0*(ph(il,i-1)-ph(il,i))*delti
+        !jyg<    Shifted part
+        ! ***         limit magnitude of mp(i) to meet cfl condition      ***
+
+        ampmax = 2.0 * (ph(il, i) - ph(il, i + 1)) * delti
+        amp2 = 2.0 * (ph(il, i - 1) - ph(il, i)) * delti
         ampmax = min(ampmax, amp2)
-        mp(il, i) = min(mp(il,i), ampmax)
-!>jyg
+        mp(il, i) = min(mp(il, i), ampmax)
+        !>jyg
 
       END IF ! (i.le.inb(il) .AND. lwork(il) .AND. i.NE.1)
     END DO
-! ----------------------------------------------------------------
+    ! ----------------------------------------------------------------
 
     IF (prt_level >= 20) THEN
       Print*, 'cv3_unsat after mp computation: mp, b(i), b(i-1) ', &
-          i, mp(1, i), b(1,i), b(1,max(i-1,1))
+              i, mp(1, i), b(1, i), b(1, max(i - 1, 1))
     ENDIF
 
-! ***       find mixing ratio of precipitating downdraft     ***
+    ! ***       find mixing ratio of precipitating downdraft     ***
 
     DO il = 1, ncum
       IF (i<inb(il) .AND. lwork(il)) THEN
-        mplus(il) = mp(il, i) > mp(il, i+1)
+        mplus(il) = mp(il, i) > mp(il, i + 1)
       END IF ! (i.lt.inb(il) .AND. lwork(il))
     END DO
@@ -3372,183 +3343,179 @@
 
           IF (cvflag_grav) THEN
-            rp(il, i) = rp(il, i+1)*mp(il, i+1) + rr(il, i)*(mp(il,i)-mp(il,i+1)) + &
-              100.*ginv*0.5*sigd(il)*(ph(il,i)-ph(il,i+1))*(evap(il,i+1)+evap(il,i))
+            rp(il, i) = rp(il, i + 1) * mp(il, i + 1) + rr(il, i) * (mp(il, i) - mp(il, i + 1)) + &
+                    100. * ginv * 0.5 * sigd(il) * (ph(il, i) - ph(il, i + 1)) * (evap(il, i + 1) + evap(il, i))
           ELSE
-            rp(il, i) = rp(il, i+1)*mp(il, i+1) + rr(il, i)*(mp(il,i)-mp(il,i+1)) + &
-              5.*sigd(il)*(ph(il,i)-ph(il,i+1))*(evap(il,i+1)+evap(il,i))
+            rp(il, i) = rp(il, i + 1) * mp(il, i + 1) + rr(il, i) * (mp(il, i) - mp(il, i + 1)) + &
+                    5. * sigd(il) * (ph(il, i) - ph(il, i + 1)) * (evap(il, i + 1) + evap(il, i))
           END IF
-          rp(il, i) = rp(il, i)/mp(il, i)
-          up(il, i) = up(il, i+1)*mp(il, i+1) + u(il, i)*(mp(il,i)-mp(il,i+1))
-          up(il, i) = up(il, i)/mp(il, i)
-          vp(il, i) = vp(il, i+1)*mp(il, i+1) + v(il, i)*(mp(il,i)-mp(il,i+1))
-          vp(il, i) = vp(il, i)/mp(il, i)
+          rp(il, i) = rp(il, i) / mp(il, i)
+          up(il, i) = up(il, i + 1) * mp(il, i + 1) + u(il, i) * (mp(il, i) - mp(il, i + 1))
+          up(il, i) = up(il, i) / mp(il, i)
+          vp(il, i) = vp(il, i + 1) * mp(il, i + 1) + v(il, i) * (mp(il, i) - mp(il, i + 1))
+          vp(il, i) = vp(il, i) / mp(il, i)
 
         ELSE ! if (mplus(il))
 
-          IF (mp(il,i+1)>1.0E-16) THEN
+          IF (mp(il, i + 1)>1.0E-16) THEN
             IF (cvflag_grav) THEN
-              rp(il, i) = rp(il,i+1) + 100.*ginv*0.5*sigd(il)*(ph(il,i)-ph(il,i+1)) * &
-                                       (evap(il,i+1)+evap(il,i))/mp(il,i+1)
+              rp(il, i) = rp(il, i + 1) + 100. * ginv * 0.5 * sigd(il) * (ph(il, i) - ph(il, i + 1)) * &
+                      (evap(il, i + 1) + evap(il, i)) / mp(il, i + 1)
             ELSE
-              rp(il, i) = rp(il,i+1) + 5.*sigd(il)*(ph(il,i)-ph(il,i+1)) * &
-                                       (evap(il,i+1)+evap(il,i))/mp(il, i+1)
+              rp(il, i) = rp(il, i + 1) + 5. * sigd(il) * (ph(il, i) - ph(il, i + 1)) * &
+                      (evap(il, i + 1) + evap(il, i)) / mp(il, i + 1)
             END IF
-            up(il, i) = up(il, i+1)
-            vp(il, i) = vp(il, i+1)
+            up(il, i) = up(il, i + 1)
+            vp(il, i) = vp(il, i + 1)
           END IF ! (mp(il,i+1).gt.1.0e-16)
         END IF ! (mplus(il)) ELSE IF (.NOT.mplus(il))
 
-        rp(il, i) = amin1(rp(il,i), rs(il,i))
-        rp(il, i) = max(rp(il,i), 0.0)
+        rp(il, i) = amin1(rp(il, i), rs(il, i))
+        rp(il, i) = max(rp(il, i), 0.0)
 
       END IF ! (i.lt.inb(il) .AND. lwork(il))
     END DO
-! ----------------------------------------------------------------
-
-! ***       find tracer concentrations in precipitating downdraft     ***
-
-!AC!      do j=1,ntra
-!AC!       do il = 1,ncum
-!AC!       if (i.lt.inb(il) .AND. lwork(il)) THEN
-!AC!c
-!AC!         IF(mplus(il))THEN
-!AC!          trap(il,i,j)=trap(il,i+1,j)*mp(il,i+1)
-!AC!     :              +trap(il,i,j)*(mp(il,i)-mp(il,i+1))
-!AC!          trap(il,i,j)=trap(il,i,j)/mp(il,i)
-!AC!         else ! if (mplus(il))
-!AC!          IF(mp(il,i+1).gt.1.0e-16)THEN
-!AC!           trap(il,i,j)=trap(il,i+1,j)
-!AC!          endif
-!AC!         endif ! (mplus(il)) ELSE IF (.NOT.mplus(il))
-!AC!c
-!AC!        endif ! (i.lt.inb(il) .AND. lwork(il))
-!AC!       enddo
-!AC!      END DO
-
-400 END DO
-! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-
-! ***                    end of downdraft loop                    ***
-
-! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-
-
-
+    ! ----------------------------------------------------------------
+
+    ! ***       find tracer concentrations in precipitating downdraft     ***
+
+    !AC!      do j=1,ntra
+    !AC!       do il = 1,ncum
+    !AC!       if (i.lt.inb(il) .AND. lwork(il)) THEN
+    !AC!c
+    !AC!         IF(mplus(il))THEN
+    !AC!          trap(il,i,j)=trap(il,i+1,j)*mp(il,i+1)
+    !AC!     :              +trap(il,i,j)*(mp(il,i)-mp(il,i+1))
+    !AC!          trap(il,i,j)=trap(il,i,j)/mp(il,i)
+    !AC!         else ! if (mplus(il))
+    !AC!          IF(mp(il,i+1).gt.1.0e-16)THEN
+    !AC!           trap(il,i,j)=trap(il,i+1,j)
+    !AC!          endif
+    !AC!         endif ! (mplus(il)) ELSE IF (.NOT.mplus(il))
+    !AC!c
+    !AC!        endif ! (i.lt.inb(il) .AND. lwork(il))
+    !AC!       enddo
+    !AC!      END DO
+
+  400 END DO
+  ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+  ! ***                    end of downdraft loop                    ***
+
+  ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
 END SUBROUTINE cv3_unsat
 
 SUBROUTINE cv3_yield(nloc, ncum, nd, na, ntra, ok_conserv_q, &
-                     icb, inb, delt, &
-                     t, rr, t_wake, rr_wake, s_wake, u, v, tra, &
-                     gz, p, ph, h, hp, lv, lf, cpn, th, th_wake, &
-                     ep, clw, qpreca, m, tp, mp, rp, up, vp, trap, &
-                     wt, water, ice, evap, fondue, faci, b, sigd, &
-                     ment, qent, hent, iflag_mix, uent, vent, &
-                     nent, elij, traent, sig, &
-                     tv, tvp, wghti, &
-                     iflag, precip, Vprecip, Vprecipi, &     ! jyg: Vprecipi
-                     ft, fr, fr_comp, fu, fv, ftra, &                 ! jyg
-                     cbmf, upwd, dnwd, dnwd0, ma, mip, &
-!!                     tls, tps,                             ! useless . jyg
-                     qcondc, wd, &
-                     ftd, fqd, qta, qtc, sigt, detrain, tau_cld_cv, coefw_cld_cv)
-
-    USE lmdz_print_control, ONLY: lunout, prt_level
-    USE add_phys_tend_mod, ONLY: fl_cor_ebil
-    USE lmdz_conema3
-    USE lmdz_cvflag
+        icb, inb, delt, &
+        t, rr, t_wake, rr_wake, s_wake, u, v, tra, &
+        gz, p, ph, h, hp, lv, lf, cpn, th, th_wake, &
+        ep, clw, qpreca, m, tp, mp, rp, up, vp, trap, &
+        wt, water, ice, evap, fondue, faci, b, sigd, &
+        ment, qent, hent, iflag_mix, uent, vent, &
+        nent, elij, traent, sig, &
+        tv, tvp, wghti, &
+        iflag, precip, Vprecip, Vprecipi, &     ! jyg: Vprecipi
+        ft, fr, fr_comp, fu, fv, ftra, &                 ! jyg
+        cbmf, upwd, dnwd, dnwd0, ma, mip, &
+        !!                     tls, tps,                             ! useless . jyg
+        qcondc, wd, &
+        ftd, fqd, qta, qtc, sigt, detrain, tau_cld_cv, coefw_cld_cv)
+
+  USE lmdz_print_control, ONLY: lunout, prt_level
+  USE add_phys_tend_mod, ONLY: fl_cor_ebil
+  USE lmdz_conema3
+  USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-  include "cvthermo.h"
-  include "cv3param.h"
-
-!inputs:
-      INTEGER, INTENT (IN)                               :: iflag_mix
-      INTEGER, INTENT (IN)                               :: ncum, nd, na, ntra, nloc
-      LOGICAL, INTENT (IN)                               :: ok_conserv_q
-      INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb
-      REAL, INTENT (IN)                                  :: delt
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, rr, u, v
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t_wake, rr_wake
-      REAL, DIMENSION (nloc), INTENT (IN)                :: s_wake
-      REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: tra
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: p
-      REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: gz, h, hp
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: th, tp
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: lv, cpn, ep, clw
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: lf
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: rp, up
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: vp
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: wt
-      REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: trap
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: water, evap, b
-      REAL, DIMENSION (nloc, na), INTENT (IN)            :: fondue, faci, ice
-      REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: qent, uent
-      REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: hent
-      REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: vent, elij
-      INTEGER, DIMENSION (nloc, nd), INTENT (IN)         :: nent
-      REAL, DIMENSION (nloc, na, na, ntra), INTENT (IN)  :: traent
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: tv, tvp, wghti
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qta
-      REAL, DIMENSION (nloc, na),INTENT(IN)              :: qpreca
-      REAL, INTENT(IN)                                   :: tau_cld_cv, coefw_cld_cv
-
-!input/output:
-      REAL, DIMENSION (nloc, na), INTENT (INOUT)         :: m, mp
-      REAL, DIMENSION (nloc, na, na), INTENT (INOUT)     :: ment
-      INTEGER, DIMENSION (nloc), INTENT (INOUT)          :: iflag
-      REAL, DIMENSION (nloc, nd), INTENT (INOUT)         :: sig
-      REAL, DIMENSION (nloc), INTENT (INOUT)             :: sigd
-
-!outputs:
-      REAL, DIMENSION (nloc), INTENT (OUT)               :: precip
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ft, fr, fu, fv , fr_comp
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ftd, fqd
-      REAL, DIMENSION (nloc, nd, ntra), INTENT (OUT)     :: ftra
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: upwd, dnwd, ma
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: dnwd0, mip
-      REAL, DIMENSION (nloc, nd+1), INTENT (OUT)         :: Vprecip
-      REAL, DIMENSION (nloc, nd+1), INTENT (OUT)         :: Vprecipi
-!!      REAL tls(nloc, nd), tps(nloc, nd)                    ! useless . jyg
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qcondc                      ! cld
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qtc, sigt                   ! cld
-      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: detrain                     ! Louis : pour le calcul de Klein du terme de variance qui détraine dans lenvironnement
-      REAL, DIMENSION (nloc), INTENT (OUT)               :: wd                          ! gust
-      REAL, DIMENSION (nloc), INTENT (OUT)               :: cbmf
-
-!local variables:
-      INTEGER                                            :: i, k, il, n, j, num1
-      REAL                                               :: rat, delti
-      REAL                                               :: ax, bx, cx, dx, ex
-      REAL                                               :: cpinv, rdcp, dpinv
-      REAL                                               :: sigaq
-      REAL, DIMENSION (nloc)                             ::  awat
-      REAL, DIMENSION (nloc, nd)                         :: lvcp, lfcp              ! , mke ! unused . jyg
-      REAL, DIMENSION (nloc)                             :: am, work, ad, amp1
-!!      real up1(nloc), dn1(nloc)
-      REAL, DIMENSION (nloc, nd, nd)                     :: up1, dn1
-!jyg<
-      REAL, DIMENSION (nloc, nd)                         :: up_to, up_from
-      REAL, DIMENSION (nloc, nd)                         :: dn_to, dn_from
-!>jyg
-      REAL, DIMENSION (nloc)                             :: asum, bsum, csum, dsum
-      REAL, DIMENSION (nloc)                             :: esum, fsum, gsum, hsum
-      REAL, DIMENSION (nloc, nd)                         :: th_wake
-      REAL, DIMENSION (nloc)                             :: alpha_qpos, alpha_qpos1
-      REAL, DIMENSION (nloc, nd)                         :: qcond, nqcond, wa           ! cld
-      REAL, DIMENSION (nloc, nd)                         :: siga, sax, mac              ! cld
-      REAL, DIMENSION (nloc)                             :: sument
-      REAL, DIMENSION (nloc, nd)                         :: sigment, qtment             ! cld
-      REAL, DIMENSION (nloc, nd, nd)                     :: qdet
-      REAL sumdq !jyg
-
-! -------------------------------------------------------------
-
-! initialization:
-
-  delti = 1.0/delt
-! PRINT*,'cv3_yield initialisation delt', delt
+  !inputs:
+  INTEGER, INTENT (IN) :: iflag_mix
+  INTEGER, INTENT (IN) :: ncum, nd, na, ntra, nloc
+  LOGICAL, INTENT (IN) :: ok_conserv_q
+  INTEGER, DIMENSION (nloc), INTENT (IN) :: icb, inb
+  REAL, INTENT (IN) :: delt
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: t, rr, u, v
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: t_wake, rr_wake
+  REAL, DIMENSION (nloc), INTENT (IN) :: s_wake
+  REAL, DIMENSION (nloc, nd, ntra), INTENT (IN) :: tra
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: p
+  REAL, DIMENSION (nloc, nd + 1), INTENT (IN) :: ph
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: gz, h, hp
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: th, tp
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: lv, cpn, ep, clw
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: lf
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: rp, up
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: vp
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: wt
+  REAL, DIMENSION (nloc, nd, ntra), INTENT (IN) :: trap
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: water, evap, b
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: fondue, faci, ice
+  REAL, DIMENSION (nloc, na, na), INTENT (IN) :: qent, uent
+  REAL, DIMENSION (nloc, na, na), INTENT (IN) :: hent
+  REAL, DIMENSION (nloc, na, na), INTENT (IN) :: vent, elij
+  INTEGER, DIMENSION (nloc, nd), INTENT (IN) :: nent
+  REAL, DIMENSION (nloc, na, na, ntra), INTENT (IN) :: traent
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: tv, tvp, wghti
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: qta
+  REAL, DIMENSION (nloc, na), INTENT(IN) :: qpreca
+  REAL, INTENT(IN) :: tau_cld_cv, coefw_cld_cv
+
+  !input/output:
+  REAL, DIMENSION (nloc, na), INTENT (INOUT) :: m, mp
+  REAL, DIMENSION (nloc, na, na), INTENT (INOUT) :: ment
+  INTEGER, DIMENSION (nloc), INTENT (INOUT) :: iflag
+  REAL, DIMENSION (nloc, nd), INTENT (INOUT) :: sig
+  REAL, DIMENSION (nloc), INTENT (INOUT) :: sigd
+
+  !outputs:
+  REAL, DIMENSION (nloc), INTENT (OUT) :: precip
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: ft, fr, fu, fv, fr_comp
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: ftd, fqd
+  REAL, DIMENSION (nloc, nd, ntra), INTENT (OUT) :: ftra
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: upwd, dnwd, ma
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: dnwd0, mip
+  REAL, DIMENSION (nloc, nd + 1), INTENT (OUT) :: Vprecip
+  REAL, DIMENSION (nloc, nd + 1), INTENT (OUT) :: Vprecipi
+  !!      REAL tls(nloc, nd), tps(nloc, nd)                    ! useless . jyg
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: qcondc                      ! cld
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: qtc, sigt                   ! cld
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: detrain                     ! Louis : pour le calcul de Klein du terme de variance qui détraine dans lenvironnement
+  REAL, DIMENSION (nloc), INTENT (OUT) :: wd                          ! gust
+  REAL, DIMENSION (nloc), INTENT (OUT) :: cbmf
+
+  !local variables:
+  INTEGER :: i, k, il, n, j, num1
+  REAL :: rat, delti
+  REAL :: ax, bx, cx, dx, ex
+  REAL :: cpinv, rdcp, dpinv
+  REAL :: sigaq
+  REAL, DIMENSION (nloc) :: awat
+  REAL, DIMENSION (nloc, nd) :: lvcp, lfcp              ! , mke ! unused . jyg
+  REAL, DIMENSION (nloc) :: am, work, ad, amp1
+  !!      real up1(nloc), dn1(nloc)
+  REAL, DIMENSION (nloc, nd, nd) :: up1, dn1
+  !jyg<
+  REAL, DIMENSION (nloc, nd) :: up_to, up_from
+  REAL, DIMENSION (nloc, nd) :: dn_to, dn_from
+  !>jyg
+  REAL, DIMENSION (nloc) :: asum, bsum, csum, dsum
+  REAL, DIMENSION (nloc) :: esum, fsum, gsum, hsum
+  REAL, DIMENSION (nloc, nd) :: th_wake
+  REAL, DIMENSION (nloc) :: alpha_qpos, alpha_qpos1
+  REAL, DIMENSION (nloc, nd) :: qcond, nqcond, wa           ! cld
+  REAL, DIMENSION (nloc, nd) :: siga, sax, mac              ! cld
+  REAL, DIMENSION (nloc) :: sument
+  REAL, DIMENSION (nloc, nd) :: sigment, qtment             ! cld
+  REAL, DIMENSION (nloc, nd, nd) :: qdet
+  REAL sumdq !jyg
+
+  ! -------------------------------------------------------------
+
+  ! initialization:
+
+  delti = 1.0 / delt
+  ! PRINT*,'cv3_yield initialisation delt', delt
 
   DO il = 1, ncum
@@ -3557,5 +3524,5 @@
   END DO
 
-!   Fluxes are on a staggered grid : loops extend up to nl+1
+  !   Fluxes are on a staggered grid : loops extend up to nl+1
   DO i = 1, nlp
     DO il = 1, ncum
@@ -3572,5 +3539,5 @@
       ft(il, i) = 0.0
       fr(il, i) = 0.0
-      fr_comp(il,i) = 0.0
+      fr_comp(il, i) = 0.0
       fu(il, i) = 0.0
       fv(il, i) = 0.0
@@ -3583,53 +3550,53 @@
       sigment(il, i) = 0.0 ! cld
       sigt(il, i) = 0.0 ! cld
-      qdet(il,i,:) = 0.0 ! cld
+      qdet(il, i, :) = 0.0 ! cld
       detrain(il, i) = 0.0 ! cld
       nqcond(il, i) = 0.0 ! cld
     END DO
   END DO
-! PRINT*,'cv3_yield initialisation 2'
-!AC!      do j=1,ntra
-!AC!       do i=1,nd
-!AC!        do il=1,ncum
-!AC!          ftra(il,i,j)=0.0
-!AC!        enddo
-!AC!       enddo
-!AC!      enddo
-! PRINT*,'cv3_yield initialisation 3'
+  ! PRINT*,'cv3_yield initialisation 2'
+  !AC!      do j=1,ntra
+  !AC!       do i=1,nd
+  !AC!        do il=1,ncum
+  !AC!          ftra(il,i,j)=0.0
+  !AC!        enddo
+  !AC!       enddo
+  !AC!      enddo
+  ! PRINT*,'cv3_yield initialisation 3'
   DO i = 1, nl
     DO il = 1, ncum
-      lvcp(il, i) = lv(il, i)/cpn(il, i)
-      lfcp(il, i) = lf(il, i)/cpn(il, i)
-    END DO
-  END DO
-
-
-
-! ***  calculate surface precipitation in mm/day     ***
+      lvcp(il, i) = lv(il, i) / cpn(il, i)
+      lfcp(il, i) = lf(il, i) / cpn(il, i)
+    END DO
+  END DO
+
+
+
+  ! ***  calculate surface precipitation in mm/day     ***
 
   DO il = 1, ncum
-    IF (ep(il,inb(il))>=0.0001 .AND. iflag(il)<=1) THEN
+    IF (ep(il, inb(il))>=0.0001 .AND. iflag(il)<=1) THEN
       IF (cvflag_ice) THEN
-        precip(il) = wt(il, 1)*sigd(il)*(water(il,1)+ice(il,1)) &
-                              *86400.*1000./(rowl*grav)
+        precip(il) = wt(il, 1) * sigd(il) * (water(il, 1) + ice(il, 1)) &
+                * 86400. * 1000. / (rowl * grav)
       ELSE
-        precip(il) = wt(il, 1)*sigd(il)*water(il, 1) &
-                              *86400.*1000./(rowl*grav)
+        precip(il) = wt(il, 1) * sigd(il) * water(il, 1) &
+                * 86400. * 1000. / (rowl * grav)
       END IF
     END IF
   END DO
-! PRINT*,'cv3_yield apres calcul precip'
-
-
-! ===  calculate vertical profile of  precipitation in kg/m2/s  ===
+  ! PRINT*,'cv3_yield apres calcul precip'
+
+
+  ! ===  calculate vertical profile of  precipitation in kg/m2/s  ===
 
   DO i = 1, nl
     DO il = 1, ncum
-      IF (ep(il,inb(il))>=0.0001 .AND. i<=inb(il) .AND. iflag(il)<=1) THEN
+      IF (ep(il, inb(il))>=0.0001 .AND. i<=inb(il) .AND. iflag(il)<=1) THEN
         IF (cvflag_ice) THEN
-          Vprecip(il, i) = wt(il, i)*sigd(il)*(water(il,i)+ice(il,i))/grav
-          Vprecipi(il, i) = wt(il, i)*sigd(il)*ice(il,i)/grav                   ! jyg
+          Vprecip(il, i) = wt(il, i) * sigd(il) * (water(il, i) + ice(il, i)) / grav
+          Vprecipi(il, i) = wt(il, i) * sigd(il) * ice(il, i) / grav                   ! jyg
         ELSE
-          Vprecip(il, i) = wt(il, i)*sigd(il)*water(il, i)/grav
+          Vprecip(il, i) = wt(il, i) * sigd(il) * water(il, i) / grav
           Vprecipi(il, i) = 0.                                                  ! jyg
         END IF
